import Test: @test, @testset
include("../day_05/code.jl")

@testset "day5" begin
    @testset "part1" begin
        @test do_1(fname, 1) == 7259358
    end
    @testset "part2" begin
        @test run_intcode("3,9,8,9,10,9,4,9,99,-1,8", 9) == 0
        @test run_intcode("3,9,8,9,10,9,4,9,99,-1,8", 8) == 1
        @test run_intcode("3,3,1108,-1,8,3,4,3,99", 9) == 0
        @test run_intcode("3,3,1108,-1,8,3,4,3,99", 8) == 1
        @test run_intcode("3,12,6,12,15,1,13,14,13,4,13,99,-1,0,1,9", 0) == 0
        @test run_intcode("3,12,6,12,15,1,13,14,13,4,13,99,-1,0,1,9", 1) == 1
        @test run_intcode("3,12,6,12,15,1,13,14,13,4,13,99,-1,0,1,9", 2) == 1
        @test run_intcode("3,3,1105,-1,9,1101,0,0,12,4,12,99,1", 0) == 0
        @test run_intcode("3,3,1105,-1,9,1101,0,0,12,4,12,99,1", 1) == 1
        @test run_intcode("3,3,1105,-1,9,1101,0,0,12,4,12,99,1", 2) == 1
        @test run_intcode("3,21,1008,21,8,20,1005,20,22,107,8,21,20,1006,20,31,1106,0,36,98,0,0,1002,21,125,20,4,20,1105,1,46,104,999,1105,1,46,1101,1000,1,20,4,20,1105,1,46,98,99", 8) == 1000
        @test run_intcode("3,21,1008,21,8,20,1005,20,22,107,8,21,20,1006,20,31,1106,0,36,98,0,0,1002,21,125,20,4,20,1105,1,46,104,999,1105,1,46,1101,1000,1,20,4,20,1105,1,46,98,99", 7) == 999
        @test run_intcode("3,21,1008,21,8,20,1005,20,22,107,8,21,20,1006,20,31,1106,0,36,98,0,0,1002,21,125,20,4,20,1105,1,46,104,999,1105,1,46,1101,1000,1,20,4,20,1105,1,46,98,99", 9) == 1001
        @test do_1(fname, 5) == 11826654
    end
end